#!/usr/bin/perl
use strict;
use warnings;

#my $gtfFile = "$ARGV[0]";
my $gtfFile = "test.gtf";
#my $gtfFile = "../Strongylocentrotus_purpuratus.GCA_000002235.2.36.gtf";

open(GTF, $gtfFile);
my @linesGTF = <GTF>;
close GTF;

my $ref_recs = &scaffoldPicker(\@linesGTF);
my @recs = @$ref_recs;

my $countA = 0;
print "#\tscaffold\tRecs\tStart\tEnd\n";
foreach my $ele (@recs) {
  $countA++;
  my @numsA = @{$ele->[2]};
  #print "$countA. $ele: @numsA\n";
  my $numGene = scalar(@numsA)/2;
  my $firstEle = shift(@numsA);
  my $lastEle  = pop(@numsA);
  print "$countA.\t$ele->[0]\t$numGene\t$firstEle\t$lastEle\n";
}

exit;

sub scaffoldPicker {

  my ($ref_linesGTFsr) = @_;
  my @linesGTFsr = @$ref_linesGTFsr;

  my %recsSR = ();  
  my $count = 0;
  my $name_scaffold = "";
  my $name_scaffold_Prev = "";
  my $flag = 0;
  my $nums = "";
  foreach my $line (@linesGTFsr) {
    $count++;
  
    next if $line =~ /^#/;
    next if $line =~ /^$/;
  
    #last if $count == 10000;
    chomp($line);
  
    unless ($line =~ /^(.*?)	.*?	.*?	(\d+)	(\d+)	.*$/){
      print "Check the structure of line (# of colums and tabs, etc).\n";
      print "\n$line\n\n";
      print "Stopped.\n";
      exit;
    }
    $name_scaffold = $1;
    my $num1 = $2;
    my $num2 = $3;
  
    if($flag == 0){
      $nums .= $num1.",";
      $nums .= $num2.",";
      $flag = 1;
      $name_scaffold_Prev = $name_scaffold; 
      next;
    }
  
    if($name_scaffold eq $name_scaffold_Prev){
      $nums .= $num1.",".$num2.",";
    }
    else {
      my @nums = split(/,/,$nums);
      my @sortedNums = sort {$a <=> $b} @nums;
      $recsSR{$name_scaffold_Prev} = \@sortedNums;
      $nums = "";
      $name_scaffold_Prev = $name_scaffold; 
      $nums .= $num1.",".$num2.",";
    }
  
  }
  my @nums = split(/,/,$nums);
  my @sortedNums = sort {$a <=> $b} @nums;
  $recsSR{$name_scaffold_Prev} = \@sortedNums;
  
  my @sortedRecsTMP = ();
  foreach my $ele (keys %recsSR) {
    my @numsB = @{$recsSR{$ele}};
    my $size = scalar(@numsB)/2;
    push(@sortedRecsTMP, [$ele , $size, $recsSR{$ele}]);
    #print "$ele $size @numsB\n";
  }
  my @sortedRecs = sort{$b->[1] <=> $a->[1]}@sortedRecsTMP;
  #foreach my $ele (@sortedRecs) {
  #  print "$ele->[0] $ele->[1] $ele->[2]\n";
  #}
  
  return(\@sortedRecs);
}
